// fuzzycluster.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//
#include "stdafx.h"
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "fuzzy_c_mean.h"

/*
	Author		: Bernd Allmendinger
	Date		: 14.02.2000
	e-mail		: webmaster@neurocomputing.de
	homepage	: www.neurocomputing.de
	Version		: 1.0
*/

int bestimmung_p_n_aus_daten(char* pfad_str, int* n, int* p);
int trimStrEnds (char* string);

int main(int argc, char* argv[])
{
/*		


Datensaetze x
x1       x2
1.7229 0.2363
1.0394 3.1764
2.5413 1.4316
0.7011 0.5562
0.0337 1.0300
2.6843 2.7687
3.9778 2.8863
3.0183 3.1279
3.8180 2.2006
3.7023 2.7614	

Aufbau der Datendatei (Beispieldate data.txt im Zip-File):
-------------------
1.7229 0.2363
1.0394 3.1764
2.5413 1.4316
0.7011 0.5562
0.0337 1.0300
2.6843 2.7687
3.9778 2.8863
3.0183 3.1279
3.8180 2.2006
3.7023 2.7614
--------------------

Insgesamt n=10 Datensatze mit Dimension p=2.

Gewaehlt wird c=2 Clusters und m=2

Ergebniss:
Fuzzy c mean Cluster Ergebnisse
===============================
n [Anzahl Datensaetze]	= 10
p [Dimension des Inputvekor]	= 2
c [Anzahl Cluster]	= 2
m [Berechnungsparameter]	= 2

Zielfunktion Jm(A) = 7.505
Anzahl benoetigter Iterationen = 23
Anzahl Cluster = 2

Cluster v
----------
Cluster 1	3.257	2.679	
Cluster 2	0.901	0.872	

Membership Funktion A
---------------------
Cluster	1	2	
n=1	0.115	0.885	
n=2	0.508	0.492	
n=3	0.592	0.408	
n=4	0.012	0.988	
n=5	0.056	0.944	
n=6	0.953	0.047	
n=7	0.960	0.040	
n=8	0.974	0.026	
n=9	0.950	0.050	
n=10	0.982	0.018	

Ausgabe Memberschip A und Daten x
											Daten
n	A1		A2		BestCluster			x1			x2	
1	0.115	0.885	2				|	1.7229000	0.2363000	
2	0.508	0.492	1				|	1.0394000	3.1764000	
3	0.592	0.408	1				|	2.5413000	1.4316000	
4	0.012	0.988	2				|	0.7011000	0.5562000	
5	0.056	0.944	2				|	0.0337000	1.0300000	
6	0.953	0.047	1				|	2.6843000	2.7687000	
7	0.960	0.040	1				|	3.9778000	2.8863000	
8	0.974	0.026	1				|	3.0183000	3.1279000	
9	0.950	0.050	1				|	3.8180000	2.2006000	
10	0.982	0.018	1				|	3.7023000	2.7614000	


*/
	char pfad_str[300], weiter[100];
	int in, ip, im, ic;
	// Parameter fuer die Berechnung-----------------------------
	// n und p werden aus dem datenfile bestimmt.
	// dabei entspricht jede zeile einem Inputdatensatzes (die
	// Anzahl der Zeilen enspricht n und
	// die Anzahl der Spalten entspricht der Dimension p des Inputvektors
	// in;	// Anzahl der Inputvekoren
	// ip;	// Dimension des Inputvekors x

	// TODO Parameter im und Anzahl Cluster setzen.
	im=2;	// Berechnungsparmater normalerweise 2
	ic=2;	// Anzahl Clustors

	// TODO hier den Pfad zur datei mit den Daten eintragen.
	// Eine Datei mit Beispieldaten befindet sich im Zip-File
	strcpy(pfad_str,"C:\\temp\\data.txt");
	if (bestimmung_p_n_aus_daten(pfad_str, &in, &ip) == 0)
		return(0);
	//-----------------------------------------------------------

	Cfuzzy_c_mean fuzzycmean(in,ip,im,ic);
			

	srand(317);
	
	if (fuzzycmean.einlesen_Matrix(pfad_str, &fuzzycmean.x, in, ip)==0)
	{	printf("File Kann nicht eingelsen werden oder ist fehlerhaft.");
		printf("Quit q:");
	 	scanf( "%s" , weiter);
		return 0; 
	}	 
	fuzzycmean.fuzzy_c_mean_cal();
	fuzzycmean.ausgabeErgebnisse();
	fuzzycmean.printErgebnisse();

	return(1);
}

// Hilfsfunktion zum Einlesen der Daten

int trimStrEnds (char* string)                                         /*
-------------------------------                                         */
{
  char *sptr;
  int n;

  sptr = string;
  while (*sptr==' ' || *sptr=='\t' || *sptr==0)
    { if (*sptr==0) break;
      *sptr++;
    }
  strcpy (string,sptr);
  n = strlen (string);
  string += --n;
  while (n>=0 && (*string==' ' || *string=='\t' || *string=='\n'))
    { n--;
      string--;
    }
  *(string+1) = 0;
  return (n+1);
}

int bestimmung_p_n_aus_daten(char* pfad_str, int* n, int* p)		/*
----------------------------------------------------------------------------	*/
{ FILE *pro;
  char str[2500], wort[100];
  char *stopstring;
  double wrt;

	/* File Format:
   	Jede zeile enthaelt anz_Spalten Zahlen (ein Datensatzt)
	 	Das File muss genau n anz_zeilen (Anzahl der datensaetze) enthalten
	*/
  *str = '\0';
  if (!(pro = fopen(pfad_str, "r")))
  { printf("Konnte File %s nicht oeffnen", pfad_str);
    return(0);
	}

  fgets (str, 2500, pro);	
  if (feof (pro)) return (0); 
 
  *p=0;
  *n=0;
  strcpy(wort, str);
  do
  {
	wrt=strtod(wort, &stopstring);
	strcpy(wort,stopstring);
	trimStrEnds(wort);
	(*p)++;
  } while (strlen(wort)!=0);

  while (!feof (pro))
  {
	fgets (str, 2500, pro);
	(*n)++;
  }
		
  return(1);	
}